| Qore Programming Language - C/C++ Library 1.0.8

Public Member Functions | List of all members
QoreTypeSafeReferenceHelper Class Reference

helper class to manage variable references passed to functions and class methods, stack only, cannot be dynamically allocated More...

`#include <QoreTypeSafeReferenceHelper.h>`

## Public Member Functions
DLLEXPORT | QoreTypeSafeReferenceHelper (const ReferenceNode *ref, ExceptionSink *xsink)
| initializes the object and tries to get the pointer to the pointer of the lvalue expression target More...
DLLEXPORT | QoreTypeSafeReferenceHelper (const ReferenceNode *ref, AutoVLock &vl, ExceptionSink *xsink)
| initializes the object and tries to get the pointer to the pointer of the lvalue expression target More...
DLLEXPORT | ~QoreTypeSafeReferenceHelper ()
| destroys the object
DLLEXPORT int | assign (QoreValue val)
| assigns a value to the reference, assumes the reference is valid More...
DLLEXPORT qore_type_t | getType () const
| returns the type of the reference's value More...
DLLEXPORT const char * | getTypeName () const
| returns the type name of the reference's value More...
DLLEXPORT AbstractQoreNode * | getUnique (ExceptionSink *xsink)
| returns a pointer to the value with a unique reference count (so it can be updated in place), assumes the reference is valid and the lvalue holds a reference-counted AbstractQoreNode*, if not, this call will cause a segfault More...
DLLEXPORT const QoreValue | getValue () const
| returns the reference's value More...
DLLEXPORT | operator bool () const
| returns true if the reference is valid, false if not More...

## Detailed Description

helper class to manage variable references passed to functions and class methods, stack only, cannot be dynamically allocated

Takes care of safely accessing ReferenceNode objects, for example when they are passed as arguments to a builtin function or method. Locks are automatically acquired in the constructor if necessary and released in the destructor. The constructor could raise a Qore-language exception if there is a deadlock acquiring any locks to access the ReferenceNode's value as given by the lvalue expression, so the object should be checked for this state right after the constructor as in the following example:

QoreValue p = get_param_value(args, 0);
if (p.getType() == NT_REFERENCE) {
const ReferenceNode *r = p.get<const ReferenceNode>();
QoreTypeSafeReferenceHelper ref(r, xsink);
// a deadlock exception occurred accessing the reference's value pointer
if (!ref)
return QoreValue();
// more code to access the reference
}

## Constructor & Destructor Documentation

## ◆ QoreTypeSafeReferenceHelper() [1/2]

DLLEXPORT QoreTypeSafeReferenceHelper::QoreTypeSafeReferenceHelper | ( | const ReferenceNode * | ref,
|  | ExceptionSink * | xsink
| ) |  |

initializes the object and tries to get the pointer to the pointer of the lvalue expression target

Parameters

  ref | the ReferenceNode to use
  xsink | Qore-language exceptions raised will be added here (for example, a deadlock accessing the object)

## ◆ QoreTypeSafeReferenceHelper() [2/2]

DLLEXPORT QoreTypeSafeReferenceHelper::QoreTypeSafeReferenceHelper | ( | const ReferenceNode * | ref,
|  | AutoVLock & | vl,
|  | ExceptionSink * | xsink
| ) |  |

initializes the object and tries to get the pointer to the pointer of the lvalue expression target

Parameters

  ref | the ReferenceNode to use
  vl | this argument is ignored in this deprecated version of the function
  xsink | Qore-language exceptions raised will be added here (for example, a deadlock accessing the object)

Deprecated:
  the AutoVLock argument is ignored in this deprecated version

## Member Function Documentation

## ◆ assign()

DLLEXPORT int QoreTypeSafeReferenceHelper::assign | ( | QoreValue | val | ) |

assigns a value to the reference, assumes the reference is valid

Parameters

  val | the value to assign (must be already referenced for the assignment)

Returns
  0 if there was no error and the variable was assigned, -1 if a Qore-language exception occured dereferencing the current value, in this case no assignment was made and the reference count for val is dereferenced automatically by the QoreTypeSafeReferenceHelper object

Note
  you must check that the reference is valid before calling this function
  QoreTypeSafeReferenceHelper rh(ref, xsink);
  // if the reference is not valid, then return
  if (!rh)
  return;
  // make the assignment (if the assignment fails, the value will be dereferenced automatically)
  rh.assign(val->refSelf());

## ◆ getType()

DLLEXPORT qore_type_t QoreTypeSafeReferenceHelper::getType | ( |  | ) | const

returns the type of the reference's value

Returns
  the type of the reference's value

## ◆ getTypeName()

DLLEXPORT const char* QoreTypeSafeReferenceHelper::getTypeName | ( |  | ) | const

returns the type name of the reference's value

Returns
  the type name of the reference's value

## ◆ getUnique()

DLLEXPORT AbstractQoreNode* QoreTypeSafeReferenceHelper::getUnique | ( | ExceptionSink * | xsink | ) |

returns a pointer to the value with a unique reference count (so it can be updated in place), assumes the reference is valid and the lvalue holds a reference-counted AbstractQoreNode*, if not, this call will cause a segfault

Parameters

  xsink | required for the call to AbstractQoreNode::deref()

Returns
  a pointer to the reference's value with a unique reference count (so it can be modified), or 0 if the value was 0 to start with or if a Qore-language exception was raised

Note
  you must check that the reference is valid before calling this function
  take care to only call this function on types where the AbstractQoreNode::realCopy() function has a valid implementation (on all value types suitable for in-place modification this function has a valid implementation), as in debugging builds other types will abort(); in non-debugging builds this function will cause a segfault

QoreTypeSafeReferenceHelper rh(ref, xsink);
// if the reference is not valid, then return
if (!rh)
return;
if (rh.getType() == NT_LIST) {
// get the unique value
QoreListNode* l = static_cast<QoreListNode*>(rh.getUnique(xsink));
// if a Qore-language exception was raised, then return
if (*xsink)
return;
}

## ◆ getValue()

DLLEXPORT const QoreValue QoreTypeSafeReferenceHelper::getValue | ( |  | ) | const

returns the reference's value

Returns
  the value of the lvalue reference

## ◆ operator bool()

DLLEXPORT QoreTypeSafeReferenceHelper::operator bool | ( |  | ) | const

returns true if the reference is valid, false if not

false will only be returned if a Qore-language exception was raised in the constructor

The documentation for this class was generated from the following file:

- include/qore/QoreTypeSafeReferenceHelper.h